import 'package:example/screens/email_signin_screen.dart';
import 'package:example/screens/email_signup_screen.dart';
import 'package:example/screens/social_login_screen.dart';
import 'package:firebase_core/firebase_core.dart';
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:ocg_app/ocg_app.dart';
import 'package:ocg_login/ocg_login.dart';
import 'package:ocg_user/ocg_user.dart';

void main() async {
  WidgetsFlutterBinding.ensureInitialized();
  await Firebase.initializeApp();
  runApp(MyApp());
}

LoginDatabase loginDatabase = LoginDatabase();

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    TokenRepository tokenRepository = LoginTokenRepository(loginDatabase);
    UserRepository userRepository =
        UserFirebaseRepository(tokenRepository, IDHelper());
    LoginRepository loginRepository = LoginFirebaseRepository(
        LoginTokenRepository(
          loginDatabase,
        ),
        userRepository);
    return MultiBlocProvider(
      providers: [
        BlocProvider<LoginBloc>(
          create: (context) => LoginBloc(
            loginRepository,
          ),
        )
      ],
      child: MaterialApp(
        title: 'Flutter Demo',
        theme: ThemeData(
          primarySwatch: Colors.blue,
          visualDensity: VisualDensity.adaptivePlatformDensity,
        ),
        home: EmailSingupScreen(),
      ),
    );
  }
}
